# gatomic.c uses SWP, which doesn't work in Thumb mode.
# Put that source file into a separate convenience library which is always built as ARM.

Index: glib-2.18.1/glib/Makefile.am
===================================================================
--- glib-2.18.1/glib/Makefile.am	2008-09-18 00:33:57.000000000 +0200
+++ glib-2.18.1/glib/Makefile.am	2008-11-08 10:13:27.000000000 +0100
@@ -80,6 +80,7 @@
 	galiasdef.c
 
 lib_LTLIBRARIES = libglib-2.0.la
+noinst_LTLIBRARIES = libgatomic.la
 
 if OS_WIN32_AND_DLL_COMPILATION
 if MS_LIB_AVAILABLE
@@ -96,10 +97,14 @@
 uninstall-ms-lib:
 	$(uninstall_ms_lib_cmd)
 
+libgatomic_la_CFLAGS = $(CFLAGS) -mno-thumb
+
+libgatomic_la_SOURCES =                \
+       gatomic.c
+ 
 libglib_2_0_la_SOURCES = 	\
 	garray.c		\
 	gasyncqueue.c		\
-	gatomic.c		\
 	gbacktrace.c		\
 	gbase64.c		\
 	gbookmarkfile.c 	\
@@ -286,8 +291,8 @@
 pcre_inc =
 endif
 
-libglib_2_0_la_LIBADD = libcharset/libcharset.la $(printf_la) @GIO@ @GSPAWN@ @PLATFORMDEP@ @ICONV_LIBS@ @G_LIBS_EXTRA@ $(pcre_lib)
-libglib_2_0_la_DEPENDENCIES = libcharset/libcharset.la $(printf_la) @GIO@ @GSPAWN@ @PLATFORMDEP@ $(glib_win32_res) $(glib_def)
+libglib_2_0_la_LIBADD = libcharset/libcharset.la $(printf_la) @GIO@ @GSPAWN@ @PLATFORMDEP@ @ICONV_LIBS@ @G_LIBS_EXTRA@ $(pcre_lib) libgatomic.la
+libglib_2_0_la_DEPENDENCIES = libcharset/libcharset.la $(printf_la) @GIO@ @GSPAWN@ @PLATFORMDEP@ $(glib_win32_res) $(glib_def) libgatomic.la
 
 libglib_2_0_la_LDFLAGS = \
 	 $(glib_win32_res_ldflag) \
